pub macro bytes32($hex_literal:expr) {
    $hex_literal.parse::<ethers::types::H256>().unwrap()
}

pub macro address($hex_literal:expr) {
    $hex_literal.parse::<ethers::types::Address>().unwrap()
}

pub macro bytes($hex_literal:expr) {{
    let hex_string = $hex_literal;
    let stripped = if hex_string.starts_with("0x") {
        &hex_string[2..]
    } else {
        &hex_string
    };
    hex::decode(stripped).expect("Invalid hex string")
}}

pub macro hex($bytes:expr) {{
    let bytes = $bytes;
    let mut hex_string = String::from("0x");
    hex_string.push_str(&hex::encode(bytes));
    hex_string
}}

pub fn byte_to_bits_be(input: u8) -> [bool; 8] {
    let mut bits = [false; 8];
    for i in 0..8 {
        bits[7 - i] = (input & (1 << i)) != 0;
    }
    bits
}
